package Calc;

import java.awt.FlowLayout;

import javax.swing.*;


/** View class for the calc app.
 * 
 * @author Hafez Seliem
 *
 */

public class View extends JFrame {
	private final Model model = new Model();
	private final JLabel valueLabel = new JLabel();

	public View() {
		setSize(300, 300);
		setVisible(true);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setLayout(new FlowLayout());
		for (int i = 0; i < 9; i++) {
			JButton digitButton = new JButton(Integer.toString(i));
			digitButton.addActionListener(new DigitListener(this, model, i));
			add(digitButton);
		}
		JButton btnplus = new JButton("+");
		add(btnplus);
		btnplus.addActionListener(new OperationListener(this, model, Op.ADD));
      
		
		JButton btnsub = new JButton("-");
		add(btnsub);
		btnsub.addActionListener(new OperationListener(this, model, Op.SUBTRACT));
		
		JButton btneq = new JButton("=");
		btneq.addActionListener(new OperationListener(this, model, Op.EQUAL));

		add(btneq);
		JButton btnclear = new JButton("clear");
		btnclear.addActionListener(new OperationListener(this, model, Op.CLEAR));

		add(btnclear);
		add(valueLabel);
		refresh();
	}

	void refresh() {
		valueLabel.setText(model.getResult());
	}

	public static void main(String[] args) {
/*	Model l = new Model();	

		l.digit(12);
		l.operation(Op.SUBTRACT );

		l.digit(5);
		l.operation(Op.EQUAL );

		System.out.println(l.getResult());
*/
		View v =new View();
		
//		
//		SwingUtilities.invokeLater(new Runnable() {
//			public void run() {
//				new View();
//			}
//		});

	}

}
